<?php

// wacs.php
// 
// a PHP implementation of the core parts of the wacs.pm perl module
//
// (C) Copyright 2007 B King
// This file is part of WACS.
//
// WACS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// WACS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with WACS; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

require_once "XMLSimple.php";

// Set the debug level
$debug = 0;

// Assumptions
$fssep = '/';

// Where to find the WACS configuration
$default_location1="/etc/wacs.d";
$default_location2="/usr/local/etc/wacs.d";
$default_location3="/opt/wacs/etc/wacs.d";
$default_specifier="WACS_CONFIG";
$main_conf = "wacs.cfg";
$main_auth = "wacs.acl";

// Global configuration objects
$treehandle=array();
$authhandle=array();
$leasehandle=array();

// DEFAULTS SECTION
$dblist=array( 
	'dateformat'=>'YYYY-MM-DD',
	'dbuser'=>'wacs',
	'dbpass'=>'wacs'
	);
$tablelist=array(
	'models'=>'models',
	'idmap'=>'idmap',
	'assoc'=>'assoc',
	'sets'=>'sets',
	'download'=>'download',
	'photographer'=>'photographer',
	'tag'=>'tag',
	'vendor'=>'vendor',
	'conn'=>'conn'
	);
$serverlist=array(
	'baseurl'=>'http://localhost/',
	'cgiurl'=>'http://localhost/cgi-bin/',
	'iconurl'=>'http://localhost/glyphs/',
	'directurl'=>'',
	'wacsurl'=>'http://localhost/wacs/',
	'wacsmain'=>'http://localhost/cgi-bin/wacsfp',
	'wacsallm'=>'http://localhost/cgi-bin/wacsmodelthumbs'
	);
$fsloclist=array(
	'images'=>'/home/images',
        'videos'=>'/home/videos',
        'glyphs'=>'/var/www/html/wacs/glyphs',
        'seticons'=>'/var/www/data/wacs/iconcache',
        'officons'=>'/var/www/data/wacs/seticons',
        'vidicons'=>'/var/www/data/wacs/vidicons',
        'dvdicons'=>'/var/www/data/wacs/dvdicons',
	'addicons'=>'/var/www/html/wacs/addicons',
        'modicons'=>'/var/www/html/wacs/icons',
        'modbigicons'=>'/var/www/html/wacs/bigicons',
        'thumbcache'=>'/var/www/html/wacs/cache',
        'download'=>'/home/wacs/download',
        'leasedir'=>'/var/run/wacs',
        'tooldir'=>'/usr/local/bin',
        'cgibindir'=>'/var/www/cgi-bin',
        'htmldir'=>'/var/www/html/wacs'
	);
$seclist=array(
	'authmode'=>'host',
	'barredusers'=>'',
        'powerusers'=>'',
        'adminusers'=>'',
        'leasetime'=>'',
        'leasefile'=>'leases.acl'
	);
$dnldlist=array(
	'actithresh'=>'2',
	'dormthresh'=>'4',
	'idlethresh'=>'120'
	);
$colourlist=array(
	'foreground'=>'#000000',
        'background'=>'#FFE8FF',
        'setbackground'=>'#FFB0FF',
        'vidbackground'=>'#FFFFB0',
        'dvdbackground'=>'#B0FFB0',
        'divider'=>'#FFA0A0',
        'indexcolours'=>'Y',
	);
$laylist=array(
	'vendormode'=>'Y',
	'thumbsize'=>'220',
        'thumbcount'=>'4',
        'minisize'=>'110'
	);
$preclist=array(
	'default'=>'sets'
        );
$iconlist=array(
        'pornstar'=>'icon3-1.png',
        'young'=>'icon3-2.png',
        'tinytit'=>'icon3-3.png',
        'nopanties'=>'icon3-4.png',
        'shaven'=>'icon3-5.png',
        'dildo'=>'icon3-6.png',
        'handsoff'=>'icon3-7.png',
        'piercedtit'=>'icon3-8.png',
        'seethru'=>'icon3-9.png',
        'outdoors'=>'icon3-10.png',
        'shorthair'=>'icon3-11.png',
        'fetish'=>'icon3-12.png',
        'nude'=>'icon3-13.png',
        'public'=>'icon3-14.png',
        'anal'=>'icon3-15.png',
        'fuck'=>'icon3-16.png',
        'lesbian'=>'icon3-17.png',
        'country'=>'icon3-18.png',
        'fisting'=>'icon3-19.png',
        'clothed'=>'icon3-20.png',
        'pissing'=>'icon3-21.png',
        'uniform'=>'icon3-22.png',
        'schoolgirl'=>'icon3-23.png',
        'tattoo'=>'icon3-24.png',
        'piercedclit'=>'icon3-25.png',
        'lipring'=>'icon3-26.png',
        'pregnant'=>'icon3-27.png',
        'bondage'=>'icon3-28.png',
        'feet'=>'icon3-29.png',
        'cheerleader'=>'icon3-30.png',
        'transport'=>'icon3-31.png',
        'weapon'=>'icon3-32.png'
        );
$modelattr=array(
        'pornstar'=>'icon3-1.png',
        'young'=>'icon3-2.png',
        'tinytit'=>'icon3-3.png',
        'shaven'=>'icon3-5.png',
        'piercedtit'=>'icon3-8.png',
        'shorthair'=>'icon3-11.png',
        'tattoo'=>'icon3-24.png',
        'piercedclit'=>'icon3-25.png',
        'lipring'=>'icon3-26.png',
	'pregnant'=>'icon3-27.png'
	);
$flaglist=array(
        'P'=>'Placeholder',
        'S'=>'Favourite Solo',
        'L'=>'Favourite Lesbian',
        'C'=>'Favourite Cutie',
        'F'=>'Favourite Straight'
        );



// end of the config file parameters
// some of the other defaults like typelist might prove useful

class Wacs {
	
// ENTRY POINT FUNCTION: read_conf
//
// Note that this attempts to be a verbatim translation of the perl
// version of equivalent routines; may not be the most elegant way to
// to do it, but it helps with keeping the two versions in step.

public function read_conf() {
	global $debug;
	global $fssep;
	global $main_conf;
	global $main_auth;
	global $treehandle;
	global $authhandle;
	global $leasehandle;
	$find_config='';
	$find_acl='';
	
	// find the main config file
	$find_config = $this->find_config_location( $main_conf );
	if( file_exists( $find_config ) )
	{
		// uses my own simplistic emulation of XMLin below
		$treehandle = $this->XMLin( $find_config );
	}
	else
	{
		if( $debug > 0 )
		{
			print "Did not find config: $find_config\n";
		}
	}
	if( $debug > 3 )
	{
		print var_dump($treehandle)."\n";
	}
	
	// find the static access control list file
	$find_acl = $this->find_config_location( $main_auth );
	if( file_exists( $find_acl ) )
	{
		// print "Found $main_auth as $find_acl\n";
		$authhandle = $this->XMLin( $find_acl );
	}
	else
	{
		print "Did not find permanent ACL: $find_acl\n";
	}

	if( $debug > 3 )
	{
		print var_dump($authhandle)."\n";
	}

	// find current leases file
	// file_exists doubles up as directory exists (tacky!)
	if( file_exists( $this->conf_get_attr("fsloc","leasedir")))
	{
		$find_lease = $this->conf_get_attr("fsloc","leasedir").
				$fssep.
				$this->conf_get_attr("security","leasefile");
	}
	else
	{
		if( $debug > 0 )
		{
			print "No directory! ".
				$this->conf_get_attr("fsloc","leasedir");
			print "Defaulting to /tmp.\n";
		}
		$find_lease = "/tmp/".
			$this->conf_get_attr("security","leasefile");
	}
	if( file_exists( $find_lease ))
	{
		$leasehandle = $this->XMLin( $find_lease );
	}
	else
	{
		if( $debug > 0 )
		{
			print "Did not find leases: ".$find_lease."\n";
		}
	}
}

// check_auth
//
// Checks that this is an authorised access to this system.
public function check_auth( $ipaddr, $vocal ) {
	global $debug;

	// ipaddr is the IP address the access is coming from
	// vocal is whether this should issue a warning or not
	// text outputing programs (vocal=1) should get please log in
	// embedded ones (vocal=0) should generate no output
	if( ! preg_match( '/^ipv4-/', $ipaddr ))
        {
                # prepend an ipv4- tag if not found (for now)
                $ipaddr = "ipv4-".$ipaddr;
        }

	if( $this->auth_get_attr( $ipaddr, "user" ) == "nobody" )
	{
		if( $debug > 3 )
		{
			print $this->auth_get_attr( $ipaddr, "user" )."\n";
		}
		// allow a global yes if the owner wishes it by an
		// all setting 
		if( $this->auth_get_attr("ipv4-all","user") != "nobody" )
		{
			// effectively a permanent yes at default
			// (lowest) access levels
			return;
		}

		// authentication has failed
		if( $vocal == 0 )
		{
			// game over
			if( $debug > 0 )
			{
				print "Unauth access attempt from ".$ipaddr.
					"\n";
			}
			exit(0);
		}
		// vocal is on
		$this->auth_error( "Authentication Required" );
		if( $debug > 0 )
		{
			print "Unauth access attempt from ".$ipaddr."\n";
		}
		exit(0);
	}
	// known user
	if( $this->auth_get_attr( $ipaddr, "type" ) == "permanent" )
	{
		// all OK - access from this address is allowed permanently
		return;
	}
	if( $this->auth_get_attr( $ipaddr, "type" ) == "lease" )
	{
		// check the lease
		$whennow = time();
		if( $this->auth_get_attr( $ipaddr, "date") > $whennow )
		{
			// lease current - all OK
			return;
		}
		else
		{
			// lease expired
			if( $debug > 0 )
			{
				print "lease expired for ".$ipaddr."\n";
			}
			if( $vocal == 1 )
			{
				$this->auth_error(
					"Sorry, your lease has expired.");
				exit(0);
			}
		}
		// lease expired and we're not vocal
		exit(0);
	}
	print "Unrecognised type in entry for ".$ipaddr."\n";
	exit(-1);
}

// auth_error
//
// do a pretty error message
public function auth_error( $message ) {
	global $debug;
        print "<html>\n";
        print "<head>\n";
        print "<title>WACS - Authentication Required</title>\n";
        print "</head>\n";
        print "<body>\n";
        print "<h1 align=center><font color=\"#FF0000\">W</font><font ";
        print "color=\"#FFFF00\">A</font><font ";
        print "color=\"#00FF00\">C</font><font ";
        print "color=\"#00FFFF\">S</font></h1>\n";
        print "<hr>\n";
        print "<center><table width=50%><tr><td align=center>\n";
        print "Access to this WACS server is restricted.  In order to ";
        print "be able to access it, you will need appropriate ";
        print "authentication credentials from the web manager of this ";
        print "installation.  If you know these and received this message ";
        print "due to expiry of a lease or by coming from a new location, you ";
        print "can <a href=\"".$this->conf_get_attr("server","cgiurl");
	print "wacslogin\">";
        print "login here</a>.\n";
        print "</td></tr></table></center>\n";
        print "<center>\n";
        print "<table border=1>\n";
        print " <tr><th>Additional Information:</th></tr>\n";
        print " <tr><td align=center>$message</td></tr>\n";
        print "</table>\n";
        print "</center>\n";
        print "<hr>\n";
        print "</body>\n";
        print "</html>\n";
}

// auth_user
//
// returns the name of the current user based upon IP address
public function auth_user( $ipaddr ) {
	global $debug;
        if( ! preg_match( '/^ipv4-/', $ipaddr ))
        {
                $ipaddr = "ipv4-".$ipaddr;
        }

        # get the registered user for this ip address from
        # the access control list
        return( $this->auth_get_attr($ipaddr,"user") );
}

// add_auth
// NB: this function is not provided in the php version of the code.

// find_config_location
//
// this routine is passed the name of a configuration file to look for
// and searches for it in the possible locations.

public function find_config_location( $try_file ) {
	global $debug;
	global $fssep;
	global $default_location1;
	global $default_location2;
	global $default_location3;
	global $default_specifier;
	$try_config='';
	// first see if the environment variable is set
	if( isset( $_ENV[$default_specifier] ) )
	{
		$try_config = $_ENV[$default_specifier].$fssep.$try_file;
		if( ! file_exists( $try_config ) )
		{
			$try_config = '';
		}
	}
	// try first default location
	if( $try_config == "" )
	{
		$try_config = $default_location1.$fssep.$try_file;
		if( ! file_exists( $try_config ) )
		{
			$try_config = '';
		}
	}
	// try second default location
	if( $try_config == "" )
	{
		$try_config = $default_location2.$fssep.$try_file;
		if( ! file_exists( $try_config ) )
		{
			$try_config = '';
		}
	}
	// try third default location
	if( $try_config == "" )
	{
		$try_config = $default_location3.$fssep.$try_file;
		if( ! file_exists( $try_config ) )
		{
			$try_config = '';
		}
	}
	// check and return result
	if( file_exists( $try_config ) )
	{
		if( $debug > 2 )
		{
			print "wacs: using config file $try_config\n";
		}
		return( $try_config );
	}
	return;
}

// conf_get_attr
//
// try to provide the requested attribute somehow

public function conf_get_attr( $req_type, $req_attr ) {
	global $debug;
	global $treehandle;
	$result='';

	if( $debug > 4 )
	{
		// print var_dump( $treehandle )."\n";
		print $treehandle["$req_type"]["$req_attr"]."\n";
	}
	$result = $treehandle["$req_type"]["$req_attr"];

	// if no result, check built-in default values
	if( empty( $result ) )
	{
		if( $debug > 4 )
                {
			print "Falling back to defaults to service:\n";
			print "  Type: $req_type\n";
			print "  Request: $req_attr\n";
		}
		if( $req_type == "database" )
		{
			$result = $this->defaults_database( $req_attr );
		}
		elseif( $req_type == "tables" )
		{
			$result = $this->defaults_tables( $req_attr );
		}
		elseif( $req_type == "server" )
		{
			$result = $this->defaults_server( $req_attr );
		}
		elseif( $req_type == "fsloc" )
		{
			$result = $this->defaults_fsloc( $req_attr );
		}
		elseif( $req_type == "security" )
		{
			$result = $this->defaults_security( $req_attr );
		}
		elseif( $req_type == "download" )
		{
                        $result = $this->defaults_download( $req_attr );
                }
                elseif( $req_type == "colours" )
                {
                        $result = $this->defaults_colours( $req_attr );
                }
                elseif( $req_type == "layout" )
                {
                        $result = $this->defaults_layout( $req_attr );
                }
                elseif( $req_type == "precedence" )
                {
                        $result = $this->defaults_precedence( $req_attr );
                }
                // embedded type requests
                elseif( $req_type == "icons" )
                {
                        $result = $this->defaults_icons( $req_attr );
                }
                elseif( $req_type == "modelattr" )
                {
                        $result = $this->defaults_modelattr( $req_attr );
                }
                else
                {
                        print "Unknown config category: $req_attr\n";
		}
	}

	if( empty( $result ))
	{
		return;
	}
	return( $result );
}

// defaults provider: database
public function defaults_database( $dbreq ) {
	global $dblist;
	return( $dblist[$dbreq] );
}

// defaults provider: tables
public function defaults_tables( $tablereq ) {
	global $tablelist;
	return( $tablelist[$tablereq] );
}

// defaults provider: server
public function defaults_server( $servreq ) {
	global $serverlist;
	return( $serverlist[$servreq] );
}

// defaults provider: fsloc
public function defaults_fsloc( $fslocreq ) {
	global $fsloclist;
	return( $fsloclist[$fslocreq] );
}

// defaults provider: security
public function defaults_security( $secreq ) {
	global $seclist;
	return( $seclist[$secreq] );
}

// defaults provider: download
public function defaults_download( $dnlreq ) {
	global $dnldlist;
	return( $dnldlist[$dnlreq] );
}

// defaults provider: colours
public function defaults_colours( $colourreq ) {
	global $colourlist;
	return( $colourlist[$colourreq] );
}

// defaults provider: layout
public function defaults_layout( $layreq ) {
	global $laylist;
	return( $laylist[$layreq] );
}

// defaults provider: precedence
public function defaults_precedence( $precreq ) {
	global $preclist;
	return( $preclist[$precreq] );
}

// defaults provider: icons
public function defaults_icons( $iconreq ) {
	global $iconlist;
	return( $iconlist[$iconreq] );
}

// defaults provider: modelattr
public function defaults_modelattr( $modareq ) {
	global $modelattr;
	return( $modelattr[$modareq] );
}

// auth_get_attr
//
// try to provide the requested access control list attribute somehow
public function auth_get_attr( $req_node, $req_attr ) {
	global $debug;
	global $authhandle;
	global $leasehandle;
	$result='';

	// first try the permanent authority file
	if( $debug > 4 )
	{
		print "Permanent: node=$req_node, attr=$req_attr\n";
		if( isset( $authhandle["$req_node"] ))
		{
			print $authhandle["$req_node"]["$req_attr"]."\n";
		}
		else
		{
			print "authhandle has no node ".$req_node."\n";
		}
	}
	if( isset( $authhandle["$req_node"] ))
	{
		$result = $authhandle["$req_node"]["$req_attr"];
	}

	// didn't get it?  try the leases
	if( empty( $result ) )
	{
		if( $debug > 4 )
                {
			print "Leases: node=$req_node, attr=$req_attr\n";
			if( isset( $leasehandle["$req_node"] ))
			{
				print $leasehandle["$req_node"]["$req_attr"].
					"\n";
			}
			else
			{
				print "leasehandle has no node ".$req_node."\n";
			}
		}
		if( isset( $leasehandle["$req_node"] ))
		{
			$result = $leasehandle["$req_node"]["$req_attr"];
		}
	}

	// if no result, check built-in default values
	if( empty($result) )
	{
		if( $debug > 4 )
		{
			print "Falling back to defaults to acls:\n";
			print "  Node: $req_node\n";
			print "  Request: $req_attr\n";
		}
		// make sure it doesn't work for everyone
                if( $req_attr == "user" )
                {
                        $result = "nobody";
                }
                elseif( $req_attr == "prefexcl" )
                {
                        $result = "";
                }
                elseif( $req_attr == "type" )
                {
                        $result = "noaccess";
                }
                elseif( $req_attr == "role" )
                {
                        $result = "viewer";
                }
                elseif( $req_attr == "date" )
                {
                        $result = 1;
                }
                else
                {
                        print "Unknown auth attribute: $req_attr\n";
                }
        }
	// manage the return
	if( empty($result) )
	{
		return;
	}
	return( $result );
}

// gettoday
//
// return todays date as a suitable string
public function gettoday( $params = array() ) {
	global $debug;
	$datefmt='';
	$fordate='';
	$whennow=0;
	$format='';
	$epoch='';
	$offset='';
	// this is a tricky translation from the perl since php can't really
	// cope with named parameters concept in the same way - to call this
	// use:
	//       gettoday( array( "format"=>"DD-MON-YYYY",
	//			  "offset"=>"5" ) );
	if( isset( $params["format"] ))
	{
		$format=$params["format"];
	}
	if( isset( $params["epoch"] ))
	{
		$epoch=$params["epoch"];
	}
	if( isset( $params["offset"] ))
	{
		$offset=$params["offset"];
	}

	// set if a format has been specified and only copy valid ones
	if( $format == "DD-MON-YYYY" )
	{
		$datefmt = "DD-MON-YYYY";
	}
	elseif( $format == "YYYY-MM-DD" )
	{
		$datefmt = "YYYY-MM-DD";
	}
	else
	{
		// no - get the wacs config value
		$datefmt = $this->conf_get_attr("database","dateformat");
	}

	// work out the time here
	$whennow = time();
	if( $epoch != "" )
	{
		// time was specified in Unix epoch format
		$whennow = $epoch;
	}
	if( $offset != "" )
	{
		$whennow = ($whennow - (86400*$offset));
	}

	// here PHP seems tidier - strftime will take us exactly where
	// we need to go directly

	// what date format is requested
	if( $datefmt == "DD-MON-YYYY" )
	{
		$fordate = strtoupper( strftime( "%d-%b-%G", $whennow ));
	}
	elseif( $datefmt == "YYYY-MM-DD" )
	{
		$fordate = strftime( "%G-%m-%d", $whennow );
	}
	else
	{
		$fordate = strftime( "%c", $whennow );
	}

	return( $fordate );
}

// timecomps
//
// Date conversion routine - takes a date as given by the database
// and converts it to three date components suitable for further
// manipulation
public function timecomps( $unconv, $specdfmt = NULL ) {
	global $debug;
	$day='';
	$month='';
	$year='';
	$mname='';
	$result=array();
	$montonum=array(
		'err'=>'0',
		'jan'=>'1',
		'feb'=>'2',
		'mar'=>'3',
		'apr'=>'4',
		'may'=>'5',
		'jun'=>'6',
		'jul'=>'7',
		'aug'=>'8',
		'sep'=>'9',
		'oct'=>'10',
		'nov'=>'11',
		'dec'=>'12' );
	
	// sanity check first
	if( ! isset( $unconv ) )
	{
		return;
	}
	// work out the input date format
	$datefmt = $this->conf_get_attr("database","dateformat");
	if( isset( $specdfmt ))
	{
		// a different one was specified from the default for this
		// database type - probably for import conversions, etc.
		$datefmt = $specdfmt;
		if( $debug > 0 )
		{
			print "timecomps: input parser set to ".
				$specdfmt."\n";
		}
	}
		
	if( $datefmt == "DD-MON-YYYY" )
	{
		// must assign result to array
		$result = explode( "-", $unconv, 3 );
		$day = $result[0];
		$mname = $result[1];
		$year = $result[2];
		$temp = strtolower( $mname );
		$month = $montonum["$temp"];
	}
	elseif( $datefmt == "YYYY-MM-DD" )
	{
		$result = explode( "-", $unconv, 3 );
		$year = $result[0];
		$month = $result[1];
		$day = $result[2];
	}
	else
	{
		// unknown, report error and return undef
		print "timecomps: Unknown date format ".$datefmt."\n";
		return;
	}

	if( $debug > 0 )
	{
		print "timecomps: ".$unconv." = day: ".$day." month: ".
			$month." year: ".$year."\n";
	}
	$result=array( '0'=>$day,
		       '1'=>$month,
		       '2'=>$year );
	return( $result );
}

// iconlink
//
public function iconlink( $params = array() ) {
        global $debug;
        $type='';
        $setno='';
        $sarea='';
        $scategory='';
        $sdirectory='';
	$model='';
	$sresize='';
	$extension='';

	// this is a tricky translation from the perl since php can't really
	// cope with named parameters concept in the same way - to call this
	// use:
	//       iconlink( array( "type"=>"I",
        //                        "setno"=>"12345",
	//		          [....] ) );
        if( isset( $params["type"] ))
        {
                $type=$params["type"];
        }
	if( isset( $params["setno"] ))
	{
		$setno=$params["setno"];
	}
	if( isset( $params["sarea"] ))
	{
		$sarea=$params["sarea"];
	}
	if( isset( $params["scategory"] ))
	{
		$scategory=$params["scategory"];
	}
	if( isset( $params["sdirectory"] ))
	{
		$sdirectory=$params["sdirectory"];
	}
	if( isset( $params["model"] ))
	{
		$model=$params["model"];
	}
	if( isset( $params["resize"] ))
	{
		$sresize=$params["resize"];
	}

	// handle image type icons
	if( $type == "I" )
	{
		// FIXME: target page should be specifiable
		print "<a href=\"".$this->conf_get_attr("server","cgiurl");
		print "wacsindex/page".$setno.".html\">";
		// usedirect is not yet supported in the php interface
		print "<img src=\"".$this->conf_get_attr("server","cgiurl");
		if( $sresize == 0) 
		{
			print "wacsimg/set".$setno.".jpg\" ";
		}
		elseif( $sresize == 1)
		{
			print "wacsimg/std".$setno.".jpg\" ";
		}
		else
		{
			print "wacsimg/mini".$setno.".jpg\" ";
		}
		print "alt=\"".$model."\">";
	}
	// handle video type icons
	if( $type == "V" )
	{
		$extension = '';
		if( preg_match( '/.wmv$/', $sdirectory ))
		{
			$extension = ".wmv";
		}
		elseif( preg_match( '/.mpg$/', $sdirectory ))
		{
			$extension = ".mpg";
		}
		elseif( preg_match( '/.mov$/', $sdirectory ))
		{
			$extension = ".mov";
		}
		else
		{
			$extension = ".avi";
		}
		print "<a href=\"".$this->conf_get_attr("server","cgiurl");
		print "wacszip/set".$setno.$extension."\">";
		print "<img src=\"".$this->conf_get_attr("server","cgiurl");
		if( $sresize == 0 )
		{
			print "wacsimg/set".$setno.".jpg\" ";
		}
		elseif( $sresize == 1 )
		{
			print "wacsimg/std".$setno.".jpg\" ";
		}
		else
		{
			print "wacsimg/mini".$setno.".jpg\" ";
		}
		print "alt=\"".$model."\">";
	}
}

//
// UNIQUE TO PHP VERSION ROUTINES:
// ===============================
//
// XMLin()
// emulation of the perl XML::Simple front door function
public function XMLin ( $xml_file ) {
	$p =& new XMLSimple();
	$p->parse( $xml_file );
	// print var_dump( $p->output );
	return( $p->output );
}

// End of wacs.php
}

?>
