<?php

// faves.php - sample program using Wacs-PHP
//
// (C) Copyright 2007 B King
// This file is part of WACS.
//
// WACS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// WACS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with WACS; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

require_once "wacs.php";
require_once 'DB.php';

$wacs = new Wacs;

// read the Wacs configuration files
$wacs->read_conf();

// check the auth(entication and authorisation) of this user
$wacs->check_auth( $_SERVER['REMOTE_ADDR'], 1 );

// database initialisation
$dbienv = $wacs->conf_get_attr("database","dbienvvar");
if( ! empty( $dbienv ))
{
	putenv($dbienv."=".$wacs->conf_get_attr("database","dbienvvalue"));
}
$dbhandle= DB::connect( $wacs->conf_get_attr("database","phpdbconnect") );
if( DB::iserror($dbhandle))
{
	print "Can't connect to database\n";
}

// start outputing web document
echo "<html>\n";
echo "<head>\n";
echo "<title>Wacs-PHP - Favourite Cuties Demo</title>\n";
echo "</head>\n";
echo "<body>\n";
echo "<h1 align=center>Wacs-PHP - Favourite Cuties Demo</h1>\n";

// do db select
//                                    0      1        2          3
$results = $dbhandle->getAll("select mname, modelno, mbigimage, mimage from ".
			$wacs->conf_get_attr("tables","models").
			" where mflag = 'C' order by mname");

// variables
$entryno = 0;
$col = 0;
// display the models
echo "<center>\n";
echo "<table>\n";
while( isset( $results[$entryno] ))
{
	// if we've done four across, start a new row
	if( $col >= 4 )
	{
		print "</tr>\n";
		$col = 0;
	}
	// if we're at zero, begin a new row
	if( $col == 0)
	{
		print "<tr>";
	}
	// output the model icon with a link around it to the model page
	// table cell start
	print "<td align=center valign=top>";
	// onwards link
	print "<a href=\"".$wacs->conf_get_attr("server","cgiurl");
	print "wacsmpthumbs/".$results[$entryno][1]."\">";
	// image
	print "<img src=\"".$wacs->conf_get_attr("server","wacsurl");
	if( ! empty( $results[$entryno][2] ))
	{
		// use bigimage
		print "bigicons/".$results[$entryno][2];
	}
	else
	{
		// fall back to small image
		print "icons/".$results[$entryno][3];
	}
	// the name and close link and table cell
	print "\"><br>".$results[$entryno][0]."</a></td>\n";
	// increment counters
	$entryno++;
	$col++;
}
// finish off the HTML
echo "</table>\n";
echo "</center>\n";
echo "</body>\n";
echo "</html>\n";
?>
